import ply.lex, ply.yacc

tokens = ('WORD', 'GREETING', 'END')

t_END = r'\!'
t_WORD = r'[A-Za-z]+'
t_GREETING = r'Hello|Hi|Howdy'

t_ignore = ' '

def t_error(t):
    raise ValueError("Illegal Character '%s'" % t.value[0])


def p_expression(p):
    """
    expression : GREETING WORD END
    """
    p[0] = 'Word 1: %s,  Word 2: %s, Sentence End: %s' % ( p[1], p[2], p[3] ) 

def p_error(p):
    raise ValueError("Illegal String '%s'" % p)


Lexer = ply.lex.lex()

Parser = ply.yacc.yacc()


try:
   hello = 'Hello World!'
   print hello,'->',Parser.parse(hello)

   hello = 'Hi World!'
   print hello,'->',Parser.parse(hello)

   hello = 'Just Hi!'
   print hello,'->',Parser.parse(hello)
except ValueError, err:
    print "Exception %s" % str(err)
